services:
  hubble:
    image: farcasterxyz/hubble:{{ farcaster_docker_image_tag }}
    pull_policy: always
    restart: always
    command: ["npx", "pm2-runtime", "start", "pm2.config.cjs"]
    mem_reservation: 16G
    healthcheck:
      test: ["CMD", "curl", "-f", "http://127.0.0.1:2281/v1/info"]
      interval: 30s
      timeout: 5s
      retries: 3
      start_period: 1m
    environment:
      CATCHUP_SYNC_WITH_SNAPSHOT: "${CATCHUP_SYNC_WITH_SNAPSHOT:-true}"
      NODE_OPTIONS: "--no-warnings --max-old-space-size=8192"
      HUBBLE_ARGS: >-
        start
        --ip 0.0.0.0
        --gossip-port ${GOSSIP_PORT:-2282}
        --rpc-port ${RPC_PORT:-2283}
        --eth-mainnet-rpc-url $ETH_MAINNET_RPC_URL
        --l2-rpc-url $OPTIMISM_L2_RPC_URL
        --network ${FC_NETWORK_ID:-1}
        --rpc-subscribe-per-ip-limit ${RPC_SUBSCRIBE_PER_IP_LIMIT:-4}
        -b ${BOOTSTRAP_NODE:-/dns/nemes.farcaster.xyz/tcp/2282}
        --hub-operator-fid ${HUB_OPERATOR_FID:-0}
        --opt-out-diagnostics ${HUB_OPT_OUT_DIAGNOSTICS:-false}
        --log-individual-messages
        ${HUB_OPTIONS:-}
    ports:
      - '${HTTPAPI_PORT:-2281}:${HTTPAPI_PORT:-2281}' # HTTP API. You can set HTTP_PORT in .env
      - '${GOSSIP_PORT:-2282}:${GOSSIP_PORT:-2282}' # Gossip. You can set GOSSIP_PORT in .env
      - '${RPC_PORT:-2283}:${RPC_PORT:-2283}' # RPC. You can set RPC_PORT in .env
    volumes:
      - /home/{{ farcaster_user }}/.hub:/home/node/app/apps/hubble/.hub
      - /home/{{ farcaster_user }}/.rocks:/home/node/app/apps/hubble/.rocks
    networks:
      - my-network
    logging:
      driver: "json-file"
      options:
        max-size: "1g"
        max-file: "2"

networks:
  my-network: